#! /bin/bash

#I first remove the double quotes and extract the treebank PCFG:
cat $1.txt | sed 's/"//g' > $1-2.txt 
java -jar ../PCFG_extractor.jar $1-2.txt $1-3.txt

#Next, I reorder the information in the grammar file format that BitPar requires:
less $1-3.txt | sed 's/%/%%/g' | awk '{printf ($NF " "); for (i=1;i<NF;i++) printf ($i " "); printf ("\n");}' | sort -nr > $1-4.txt

#(the s/%/%%/g is necessary because % is a reserved symbol for awk). 

#Then, I extract a dummy 'lexicon' file from it in the format that BitPar requires
echo "Lexicon"
less $1-4.txt | grep -E '"[^"]+"' | sed 's/\"//g' | awk '{print($3"\t"$2"\t"$1)}' | tr [A-Z] [a-z] > $1-lexicon

rm $1-2.txt
rm $1-3.txt
rm $1-4.txt

#translate words in corpus to POS-tags
awk 'NR==FNR{a[$1]=$2;next;}{print $1,$2; printf NF-3 " "; for (i=3; i<=NF; i++){print a[$i];} print "|"}' $1-lexicon topics/keys.txt | tr '\n' ' ' | tr '|' '\n' | grep -o '[^ ].*'> topics/keys-pos-tags.txt

