package sned;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.LinkedList;
import java.util.List;


public class Corpus {

	List<Sentence> sentences = new LinkedList<Sentence>();

	public Corpus(String filename) {
		loadCorpus(filename);
	}

	public List<Sentence> sentences() {
		return sentences;
	}

	private void loadCorpus(String filename) {
		System.out.println("Loading corpus POS-tags...");
		try {
			BufferedReader in = new BufferedReader(new FileReader(filename));
			String line;
			while ((line = in.readLine()) != null) {
				sentences.add(Sentence.fromCorpusLine(line));
			}
			in.close();
		}
		catch (Exception e) {
			System.out.println("Failed to load POS-tag span substitution costs");
			e.printStackTrace();
		}
		System.out.println("Loaded " + sentences.size() + " sentences");
	}

}
