package sned;



public class Evaluator {

    int truePositives = 0;
    int goldSize = 0;
    int trainSize = 0;

    public Evaluator() {}

    public void addTestResults(int truePositives, int goldSize, int trainSize) {
        this.truePositives += truePositives;
        this.goldSize += goldSize;
        this.trainSize += trainSize;
    }

    public double getPrecision() {
        return (double)truePositives / (double)trainSize;
    }

    public double getRecall() {
        return (double)truePositives / (double)goldSize;
    }

    public double getF1() {
        double recall = getRecall();
        double precision = getPrecision();
        return 2 * recall * precision / (precision + recall);
    }

    public void printResults() {
        System.out.println("Precision: " + getPrecision());
        System.out.println("Recall:    " + getRecall());
        System.out.println("F1 score:  " + getF1());
        
        System.out.println("truePositives: " + truePositives + "\ttrainSize: " + trainSize + "\tgoldSize: " + goldSize);
    }
}
