/*
@author: Peter Csiba & Peter Schmidt (emails petherz at gmail dot com & petersch.home at gmail dot com)

The code is provided without any warranty or documentation.
Check out http://www.csip.sk/
*/

package sned;

import java.util.List;

public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		System.out.println("#### normal [0.5;1.0] (best) check recall ####");

		Corpus test_corpus = new Corpus("data/corpus_test.txt");
		List<PCFGTree> test_pcfg = PCFGTree.parseCorpus("data/corpus_test_gold.txt");

		SNED s = new SNED();
		Evaluator e = new Evaluator();

		StringBuilder stats = new StringBuilder();

		//for(int i=0; i<test_corpus.sentences.size() ; i++){
		for(int i=0; i<test_corpus.sentences.size() ; i++){
			System.out.println("#"+i);
			Constituent bestTree = s.searchNeighbors(test_corpus.sentences.get(i));
			if(bestTree != null){
				System.out.println("Target:    " + test_pcfg.get(i));
				String stats_f1 = s.evaluate(bestTree, test_pcfg.get(i), e);
				System.out.println("----------------------------------");

				stats.append(s.lsh_count + "\t" + stats_f1 + "\t" + bestTree + "\t" + test_pcfg.get(i) + "\n");
			}
		}

		System.out.println(stats.toString());

		e.printResults();

		/* WORKS
		List<PCFGTree> exemplars = PCFGTree.parseCorpus("data/corpus_train_gold.txt");
		for(int i=0; i<3; i++){
			for(String span : exemplars.get(i).getAllConstituentSpans()){
				System.out.println(span);
			}
			System.out.println("------------------");
		}*/

		/* WORKS
		Sentence sen = new Sentence("a b c d e f");
		List<Constituent> parse_trees = Constituent.getAllParseTrees(sen);
		for(Constituent con : parse_trees){
			System.out.println(con);
		}
		System.out.println(sen + " parse_count=" + parse_trees.size()); */

		/*System.out.println(s.getDistance(new Sentence(""), new Sentence("")));
		System.out.println(s.getDistance(new Sentence(""), new Sentence("a")));
		System.out.println(s.getDistance(new Sentence("b"), new Sentence("a")));
		System.out.println(s.getDistance(new Sentence("a b c"), new Sentence("")));
		System.out.println(s.getDistance(new Sentence("a b c"), new Sentence("a b c")));
		System.out.println(s.getDistance(new Sentence("a b c"), new Sentence("a g c")));
		System.out.println(s.getDistance(new Sentence("a b d"), new Sentence("a b e")));
		System.out.println(s.getDistance(new Sentence("a b c"), new Sentence("d e f")));*/
		//System.out.println(s.getDistance(new Sentence("a b c d e f"), new Sentence("a x y d z w")));
		//System.out.println(s.getDistance(new Sentence("a b c d e f"), new Sentence("g h i j k l")));

	}

}
