package sned;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class PCFGRule {
	public String left;
	public List<String> right; 

	public PCFGRule(){
		left = null;
		right = new ArrayList<String>();
	}
	
	public PCFGRule(String s){
		left = s.substring(0, s.indexOf(':'));
		right = Arrays.asList(s.substring(s.indexOf(':')+1).split(","));
	}
	
	public String getRightAsString(){
		StringBuilder sb = new StringBuilder();
		boolean first = true;
		for(String s: right) {
			if(!first){
				sb.append(",");
			}
			sb.append(s);
			first = false;
		}
		return sb.toString();
	}
	
	public String toString(){
		return left + ":" + getRightAsString(); 
	}
}
