/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sned;

import java.util.Map;

/**
 *
 * @author pepo
 */
public class SentenceSpan {
    
    private Sentence sentence;
    private int first, last;
    
    private String string = null;
    
    private Integer index = -1;
    
	public final static SentenceSpan EMPTY = new SentenceSpan();
    
    public SentenceSpan() {
        this.sentence = Sentence.EMPTY;
        first = 1;
        last = 0;
    }
    
    public SentenceSpan(Sentence s, int i, int j) {
        this.sentence = s;
        this.first = i;
        this.last = j;
    }
    
    public SentenceSpan getSpan(int i, int j) {
        //return sentence.getSpan(i, j);
        return new SentenceSpan(sentence, first + i -1, first + j - 1);
    }
    
    public String getLabel(int i) {
        return sentence.getLabel(i + first - 1);
    }
    
    public String leftContext() {
        if (first == 1) return null;
        else return sentence.words().get(first-2);
    }
    
    public String rightContext() {
        if (last == sentence.words().size()) return null;
        else return sentence.words().get(last);
    }
    
    public int length() {
        return last - first + 1;
    }
    
	public boolean equals(Object o) {
		if (o instanceof SentenceSpan) {
			SentenceSpan ss = (SentenceSpan)o;
			if (ss.length() == this.length()) {
				for (int i = 0; i < this.length(); ++i) {
					if (!this.sentence.labels().get(i).equals(ss.sentence.labels().get(i))) {
						return false;
					}
				}
				return true;
			}
		}
		return false;
	}

	public String toString() {
        if (string == null) {
            // vyrobi nieco taketo "PP,NN,VBS,NNS"
            if (sentence.labels() == null) return "null";
            if (sentence.labels().size() == 0) return "";

            StringBuilder result = new StringBuilder();
            for (int i = first; i <= last; ++i) {
                if (i != first) result.append(",");
                result.append(sentence.labels().get(i-1));
            }
            string = result.toString();
        }
        return string;
	}
    
    public Integer getIndex(Map<String, Integer> map) {
        if (index == null) {
            return null;
        }
        if (index == -1) {
            index = map.get(this.toString());
        }
        return index;
    }
    
}
