
package utils;

public class Pair<F extends Comparable<F>, S extends Comparable<S>> implements Comparable<Pair<F,S>> {
    public F first;
    public S second;
    public Pair(F f, S s) { first = f; second = s; }
    public int hashCode() { return first.hashCode() << 16 + second.hashCode(); }
    public boolean equals(Object o) {
        if (o instanceof Pair) {
            Pair p = (Pair)o;
            return (first == p.first && second == p.second);
        }
        return false;
    }
    public int compareTo(Pair<F,S> p) {
        if (this.first.compareTo(p.first) < 0) return -1;
        if (this.first.compareTo(p.first) > 0) return 1;

        if (this.second.compareTo(p.second) < 0) return -1;
        if (this.second.compareTo(p.second) > 0) return 1;

        return 0;
    }
}
